diff --git a/tests/TestSuite_l2fwd.py b/tests/TestSuite_l2fwd.py
index 091ac093..2c448583 100644
--- a/tests/TestSuite_l2fwd.py
+++ b/tests/TestSuite_l2fwd.py
@@ -175,7 +175,7 @@ class TestL2fwd(TestCase):
         eal_params = self.dut.create_eal_parameters(cores=cores)
         eal_param = ""
         for i in ports:
-            eal_param += " -w %s" % self.dut.ports_info[i]['pci']
+            eal_param += " -a %s" % self.dut.ports_info[i]['pci']
 
         for frame_size in self.frame_sizes:
 
diff --git a/tests/TestSuite_multiprocess.py b/tests/TestSuite_multiprocess.py
index 8752a727..3a0b6780 100644
--- a/tests/TestSuite_multiprocess.py
+++ b/tests/TestSuite_multiprocess.py
@@ -84,7 +84,7 @@ class TestMultiprocess(TestCase):
 
         self.eal_param = ""
         for i in self.dut_ports:
-            self.eal_param += " -w %s" % self.dut.ports_info[i]['pci']
+            self.eal_param += " -a %s" % self.dut.ports_info[i]['pci']
 
         self.eal_para = self.dut.create_eal_parameters(cores='1S/2C/1T')
         # start new session to run secondary
diff --git a/tests/TestSuite_nic_single_core_perf.py b/tests/TestSuite_nic_single_core_perf.py
index 4ccc04ac..c247ae7e 100644
--- a/tests/TestSuite_nic_single_core_perf.py
+++ b/tests/TestSuite_nic_single_core_perf.py
@@ -220,7 +220,7 @@ class TestNicSingleCorePerf(TestCase):
         # ports allowlist
         eal_para = ""
         for i in range(port_num):
-            eal_para += " -w " + self.dut.ports_info[i]['pci']
+            eal_para += " -a " + self.dut.ports_info[i]['pci']
 
         port_mask = utils.create_mask(self.dut_ports)
 
diff --git a/tests/TestSuite_performance_thread.py b/tests/TestSuite_performance_thread.py
index 459d9a11..0928df8b 100644
--- a/tests/TestSuite_performance_thread.py
+++ b/tests/TestSuite_performance_thread.py
@@ -189,7 +189,7 @@ class TestPerformanceThread(TestCase):
         self.test_results["data"] = []
         eal_param = ""
         for i in valports:
-            eal_param += " -w %s" % self.dut.ports_info[i]['pci']
+            eal_param += " -a %s" % self.dut.ports_info[i]['pci']
 
         for cores in self.nb_cores:
             core_list, core_mask = self.create_cores(cores)
diff --git a/tests/TestSuite_vf_l3fwd.py b/tests/TestSuite_vf_l3fwd.py
index a9bc7fa4..c881f69f 100644
--- a/tests/TestSuite_vf_l3fwd.py
+++ b/tests/TestSuite_vf_l3fwd.py
@@ -128,7 +128,7 @@ class TestVfL3fwd(TestCase):
                 self.host_testpmd = PmdOutput(self.dut)
                 eal_param = '--socket-mem=1024,1024 --file-prefix=pf'
                 for i in valports:
-                    eal_param += ' -w %s' % self.dut.ports_info[i]['pci']
+                    eal_param += ' -a %s' % self.dut.ports_info[i]['pci']
                 core_config = self.cores[:len(valports)]
                 self.host_testpmd.start_testpmd(core_config, "", eal_param=eal_param)
                 for i in valports:
@@ -256,7 +256,7 @@ class TestVfL3fwd(TestCase):
         self.setup_vf_env(host_driver, vf_driver)
         eal_param = ""
         for i in valports:
-            eal_param += " -w " + self.sriov_vfs_port[i][0].pci
+            eal_param += " -a " + self.sriov_vfs_port[i][0].pci
         port_mask = utils.create_mask(self.dut_ports)
 
         # for fvl40g, fvl25g, use 2c/2q per VF port for performance test ,
diff --git a/tests/TestSuite_vf_single_core_perf.py b/tests/TestSuite_vf_single_core_perf.py
index d40547cd..53ee2da7 100644
--- a/tests/TestSuite_vf_single_core_perf.py
+++ b/tests/TestSuite_vf_single_core_perf.py
@@ -225,7 +225,7 @@ class TestVfSingleCorePerf(TestCase):
         # ports allowlist
         eal_para = ""
         for i in range(port_num):
-            eal_para += " -w " + self.sriov_vfs_port[i][0].pci
+            eal_para += " -a " + self.sriov_vfs_port[i][0].pci
         port_mask = utils.create_mask(self.dut_ports)
         # parameters for application/testpmd
         param = " --portmask=%s" % (port_mask)
diff --git a/tests/TestSuite_vmdq.py b/tests/TestSuite_vmdq.py
index 6dae54a4..1a170f89 100644
--- a/tests/TestSuite_vmdq.py
+++ b/tests/TestSuite_vmdq.py
@@ -113,7 +113,7 @@ class TestVmdq(TestCase):
         port_mask = utils.create_mask(self.dut_ports)
         eal_param = ""
         for i in self.dut_ports:
-            eal_param += " -w %s" % self.dut.ports_info[i]['pci']
+            eal_param += " -a %s" % self.dut.ports_info[i]['pci']
         # Run the application
         self.dut.send_expect("./%s -c %s -n 4 %s -- -p %s --nb-pools %s --enable-rss" %
                              (self.app_vmdq_path, core_mask, eal_param, port_mask, str(npools)), "reading queues", 120)
diff --git a/tests/TestSuite_vmdq_dcb.py b/tests/TestSuite_vmdq_dcb.py
index 2a248f8c..20d03dde 100644
--- a/tests/TestSuite_vmdq_dcb.py
+++ b/tests/TestSuite_vmdq_dcb.py
@@ -107,7 +107,7 @@ class TestVmdqDcb(TestCase):
         port_mask = utils.create_mask(self.dut_ports)
         eal_param = ""
         for i in self.dut_ports:
-            eal_param += " -w %s" % self.dut.ports_info[i]['pci']
+            eal_param += " -a %s" % self.dut.ports_info[i]['pci']
         # Run the application
         app_name = self.dut.apps_name['vmdq_dcb']
         command = app_name + "-c %s -n 4 %s -- -p %s --nb-pools %s --nb-tcs %s " \