diff --git a/tests/TestSuite_generic_filter.py b/tests/TestSuite_generic_filter.py
index 22f85bd0..173e4f72 100644
--- a/tests/TestSuite_generic_filter.py
+++ b/tests/TestSuite_generic_filter.py
@@ -416,89 +416,6 @@ class TestGeneric_filter(TestCase):
 
         self.verify_result(out, tx_pkts="1", expect_queue="0")
 
-    def test_multiple_filters_10GB(self):
-        if self.nic in ["niantic", "sagepond", "sageville", "fortville_eagle", "fortville_25g", "fortville_spirit", "columbiaville_25g", "columbiaville_100g"]:
-            self.pmdout.start_testpmd(
-                "%s" % self.cores, "--disable-rss --rxq=4 --txq=4 --portmask=%s --nb-cores=4 --nb-ports=1" % portMask)
-            self.port_config()
-            self.dut.send_expect(
-                "syn_filter %s add priority high queue 1" % valports[0], "testpmd> ")
-            self.dut.send_expect(
-                "ethertype_filter %s add mac_ignr 00:00:00:00:00:00 ethertype 0x0806 fwd queue 2" % valports[0], "testpmd> ")
-            self.dut.send_expect(
-                "5tuple_filter %s add dst_ip 2.2.2.5 src_ip 2.2.2.4 dst_port 1 src_port 1 protocol 0x06 mask 0x1f tcp_flags 0x0 priority 3 queue 3 " % (valports[0]), "testpmd> ")
-            self.dut.send_expect("start", "testpmd> ")
-
-            self.filter_send_packet("syn")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="1")
-
-            self.ethertype_filter = "on"
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("arp")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="2")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("arp_prio")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="2")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("fivetuple")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="3")
-
-            self.dut.send_expect(
-                "5tuple_filter %s del dst_ip 2.2.2.5 src_ip 2.2.2.4 dst_port 1 src_port 1 protocol 0x06 mask 0x1f tcp_flags 0x0 priority 3 queue 3 " % (valports[0]), "testpmd> ")
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("syn")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="1")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("arp")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="2")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("fivetuple")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="0")
-            self.dut.send_expect(
-                "ethertype_filter %s del mac_ignr 00:00:00:00:00:00 ethertype 0x0806 fwd queue 2" % valports[0], "testpmd> ")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("arp")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="0")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("syn")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="1")
-
-            self.dut.send_expect(
-                "syn_filter %s del priority high queue 1" % valports[0], "testpmd> ")
-
-            self.dut.send_expect("start", "testpmd> ")
-            self.filter_send_packet("syn")
-            out = self.dut.send_expect("stop", "testpmd> ")
-            self.dut.send_expect("clear port stats all", "testpmd> ")
-            self.verify_result(out, tx_pkts="1", expect_queue="0")
-
-        else:
-            self.verify(False, "%s nic not support this test" % self.nic)
-
     def test_twotuple_filter(self):
 
         if self.nic in ["powerville", "bartonhills", "cavium_a063", "sagepond", "foxville", "sageville", "fortville_eagle", "fortville_25g", "fortville_spirit", "columbiaville_25g", "columbiaville_100g"]:
@@ -631,80 +548,6 @@ class TestGeneric_filter(TestCase):
             self.verify_result(out, tx_pkts="1", expect_queue="0")
         else:
             self.verify(False, "%s nic not support this test" % self.nic)
-    def test_jumbo_frame_size(self):
-        
-        self.verify(self.nic not in ["fortville_spirit_single", "fortpark_TLV","fortpark_BASE-T", "carlsville"], "%s nic not support this test" % self.nic)
-        if (self.nic in ["cavium_a063", "cavium_a064", "foxville"]):
-            self.pmdout.start_testpmd(
-                "%s" % self.cores, "--disable-rss --rxq=4 --txq=4 --portmask=%s --nb-cores=4 --nb-ports=1 --mbcache=200 --mbuf-size=2048 --max-pkt-len=9200" % portMask)
-        else:
-            self.pmdout.start_testpmd(
-                "%s" % self.cores, "--disable-rss --rxq=4 --txq=4 --portmask=%s --nb-cores=4 --nb-ports=1 --mbcache=200 --mbuf-size=2048 --max-pkt-len=9600" % portMask)
-        port = self.tester.get_local_port(valports[0])
-        txItf = self.tester.get_interface(port)
-
-        port = self.tester.get_local_port(valports[1])
-        rxItf = self.tester.get_interface(port)
-        self.tester.send_expect("ifconfig %s mtu %s" % (txItf, 9200), "# ")
-        self.tester.send_expect("ifconfig %s mtu %s" % (rxItf, 9200), "# ")
-
-        self.dut.send_expect(
-            "set stat_qmap rx %s 0 0" % valports[0], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 0 0" % valports[1], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 1 1" % valports[0], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 1 1" % valports[1], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 2 2" % valports[0], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 2 2" % valports[1], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 3 3" % valports[0], "testpmd> ")
-        self.dut.send_expect(
-            "set stat_qmap rx %s 3 3" % valports[1], "testpmd> ")
-        self.dut.send_expect(
-            "vlan set strip off %s" % valports[0], "testpmd> ")
-        self.dut.send_expect(
-            "vlan set strip off %s" % valports[1], "testpmd> ")
-        self.dut.send_expect(
-            "vlan set filter off %s" % valports[0], "testpmd> ")
-        self.dut.send_expect(
-            "vlan set filter off %s" % valports[1], "testpmd> ")
-        self.dut.send_expect(
-            "syn_filter %s add priority high queue 2" % valports[0], "testpmd> ")
-
-        self.dut.send_expect("start", "testpmd> ", 120)
-
-        self.filter_send_packet("jumbo")
-        time.sleep(1)
-
-        out = self.dut.send_expect("stop", "testpmd> ")
-        self.dut.send_expect("clear port stats all", "testpmd>")
-
-        self.verify_result(out, tx_pkts="1", expect_queue="2")
-
-        self.dut.send_expect("start", "testpmd> ")
-
-        self.filter_send_packet("arp")
-        time.sleep(1)
-        out = self.dut.send_expect("stop", "testpmd> ")
-        self.dut.send_expect("clear port stats all", "testpmd>")
-
-        self.verify_result(out, tx_pkts="1", expect_queue="0")
-
-        self.dut.send_expect(
-            "syn_filter %s del priority high queue 2" % valports[0], "testpmd> ")
-        self.dut.send_expect("start", "testpmd> ", 120)
-        self.filter_send_packet("jumbo")
-        time.sleep(1)
-        out = self.dut.send_expect("stop", "testpmd> ")
-        self.dut.send_expect("clear port stats all", "testpmd>")
-
-        self.verify_result(out, tx_pkts="1", expect_queue="0")
-        self.tester.send_expect("ifconfig %s mtu %s" % (txItf, 1500), "# ")
-        self.tester.send_expect("ifconfig %s mtu %s" % (rxItf, 1500), "# ")
 
     def test_128_queues(self):
         # testpmd can't support assign queue to received packet, so can't test